/*
 *	Simple User Authentication System -- Global Declarations
 *
 *	(c) 1996 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License. See file COPYING in any of the GNU utilities.
 */

#define NO_RET __attribute__ ((noreturn))

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned int ulg;

/* Configuration */

#define SUA_SESSION_BIN_KEY_SIZE 15		/* These parameters are >magic< ! */
#define SUA_SESSION_KEY_SIZE 20
#define SUA_USER_BIN_KEY_SIZE 15
#define SUA_USER_KEY_SIZE 20
#define SUA_USER_BIN_SALT_SIZE 15
#define SUA_USER_SALT_SIZE 20
#define SUA_NET_BIN_KEY_SIZE 15
#define SUA_NET_KEY_SIZE 20

#define SUA_SERVER_PORT 997
#define SUA_CLIENT_MASTER_PORT 998

#define SUA_USER_LIST_FILE "/etc/suas/userlist"
#define SUA_USER_LIST_BAK_FILE "/etc/suas/userlist.old"
#define SUA_CLIENT_LIST_FILE "/etc/suas/clientlist"
#define SUA_LOG_FILE "/var/log/sualog"

#define SUA_TIMEOUT 120
#define SUA_RETRY_TIMEOUT 1
#define SUA_BANNER1 "+SUAS 0.9 Ready. Session key is <"
#define SUA_BANNER2 ">\n"
#define SUA_REFRESH 30

/* sualib.c */

extern char program_name[];

void die(char *, ...) NO_RET;
void *xmalloc(ulg);
char *syserr(void);
void encrypt_first(char *, char *);
void encrypt_local(char *, char *, char *);
void encrypt_net(char *, char *, char *);
void encode_base64(byte *, char *, int);
void generate_random(char *, ulg);
